Wt: Wt::WDialog Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Protected Member Functions | List of all members
Wt::WDialog Class Reference

A WDialog shows a dialog. More...

`#include <Wt/WDialog.h>`

Inheritance diagram for Wt::WDialog:
[legend]

## Public Types
typedef DialogCode | Code
| Typedef for enum Wt::DialogCode.
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.

## Public Member Functions
| WDialog ()
| Constructs a new dialog.
| WDialog (const WString &windowTitle)
| Constructs a dialog with a given window title.
| ~WDialog ()
| Deletes a dialog.
void | setWindowTitle (const WString &title)
| Sets the dialog window title.
WString | windowTitle () const
| Returns the dialog window title.
void | setTitleBarEnabled (bool enabled)
| Enables or disables the title bar.
bool | isTitleBarEnabled () const
| Returns whether the title bar is enabled.
WContainerWidget * | titleBar () const
| Returns the dialog title bar container.
WContainerWidget * | contents () const
| Returns the dialog contents container.
WContainerWidget * | footer () const
| Returns the dialog footer container.
DialogCode | exec (const WAnimation &animation=WAnimation())
| Executes the dialog in a recursive event loop.
virtual void | done (DialogCode r)
| Stops the dialog.
virtual void | accept ()
| Closes the dialog, with result is Accepted.
virtual void | reject ()
| Closes the dialog, with result is Rejected.
void | rejectWhenEscapePressed (bool enable=true)
| Lets pressing the escape key reject the dialog.
Signal< DialogCode > & | finished ()
| Signal emitted when the dialog is closed.
DialogCode | result () const
| Returns the result that was set for this dialog.
void | setModal (bool modal)
| Sets whether the dialog is modal.
bool | isModal () const
| Returns whether the dialog is modal.
void | setResizable (bool resizable)
| Adds a resize handle to the dialog.
bool | resizable () const
| Returns whether the dialog has a resize handle.
void | setMovable (bool movable)
| Allows the dialog to be moved.
bool | movable () const
| Returns whether the dialog can be moved.
void | setClosable (bool closable)
| Adds a close button to the titlebar.
bool | closable () const
| Returns whether the dialog can be closed.
void | setAutoFocus (bool enable)
| Set focus on the first widget in the dialog.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical) override
| Positions a widget next to another widget.
void | positionAt (const Wt::WMouseEvent &ev)
| Set the position of the widget at the mouse position.
void | raiseToFront ()
| Raises this dialog to be the top-most dialog.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
JSignal< int, int > & | resized ()
| Signal emitted when the dialog is being resized by the user.
JSignal< int, int > & | moved ()
| Signal emitted when the dialog is being moved by the user.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
keyboard and mouse events
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
Public Member Functions inherited from Wt::WPopupWidget
| WPopupWidget (std::unique_ptr< WWidget > impl)
| Constructor.
virtual | ~WPopupWidget ()
| Destructor.
void | setAnchorWidget (WWidget *widget, Orientation orientation=Orientation::Vertical)
| Sets an anchor widget.
Orientation | orientation () const
| Returns the orientation.
void | setTransient (bool transient, int autoHideDelay=0)
| Sets transient property.
bool | isTransient () const
| Returns whether the popup is transient.
int | autoHideDelay () const
| Returns the auto-hide delay.
Signal & | hidden ()
| Signal emitted when the popup is hidden.
Signal & | shown ()
| Signal emitted when the popup is shown.
Public Member Functions inherited from Wt::WCompositeWidget
| WCompositeWidget ()
| Creates a WCompositeWidget.
| WCompositeWidget (std::unique_ptr< WWidget > implementation)
| Creates a WCompositeWidget with given implementation.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
virtual std::string | objectName () const override
| Returns the object name.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength::Auto) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &name) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &js) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WPopupWidget
Protected Member Functions inherited from Wt::WCompositeWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
void | setImplementation (std::unique_ptr< WWidget > widget)
| Set the implementation widget.
template<typename Widget >
Widget * | setImplementation (std::unique_ptr< Widget > widget)
| Sets the implementation widget, returning a raw pointer.
template<typename W , typename... Args>
W * | setNewImplementation (Args &&... args)
| Creates the implementation widget and sets it, returning a raw pointer.
WWidget * | implementation ()
| Get the implementation widget.
virtual int | boxPadding (Orientation orientation) const override
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const override
| Returns the widget's built-in border width.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A WDialog shows a dialog.

By default, the dialog is modal. A modal window blocks the user interface, and does not allow the user to interact with any other part of the user interface until the dialog is closed (this is enforced at the server side, so you may rely on this behavior).

A modal dialog can be instantiated synchronously or asynchronously. A non-modal dialog can only be instantiated asynchronously.

When using a dialog asynchronously, there is no API call that waits for the dialog to be closed. Then, the usage is similar to instantiating any other widget. The dialog may be closed by calling accept(), reject() or done() (or connecting a signal to one of these methods). This will hide the dialog and emit the finished() signal, which you then can listen for to process the dialog result and delete the dialog. Unlike other widgets, a dialog does not need to be added to a parent widget, but is hidden by default. You must use the method show() or setHidden(false) to show the dialog.

The synchronous use of a dialog involves a call to exec() which will block (suspend the thread) until the dialog window is closed, and return the dialog result. Events within dialog are handled using a so-called recursive event loop. Typically, an OK button will be connected to accept(), and in some cases a StandardButton::Cancel button to reject(). This solution has the drawback that it is not scalable to many concurrent sessions, since for every session with a recursive event loop, a thread is locked until exec() returns. A thread that is locked by a recursive event loop cannot be used to process requests from another sessions. When all threads in the threadpool are locked in recursive event loops, the server will be unresponsive to requests from any other session. In practical terms, this means you must not use exec(), unless your application will never be used by more concurrent users than the amount of threads in your threadpool (like on some intranets or extranets). Using exec() is not supported from outside the regular event loop (i.e. when taking a lock on a session using WApplication::getUpdateLock() or by posting an event using WServer::post()).

Use setModal(false) to create a non-modal dialog. A non-modal dialog does not block the underlying user interface: the user must not first deal with the dialog before interacting with the rest of the user interface.

Contents for the dialog is defined by adding it to the contents() widget.

Usage example, using the exec() method (not recommended):

Wt::WDialog dialog("Personalia");
dialog.contents()->addWidget(std::make_unique<Wt::WText>("Enter your name: "));
dialog.contents()->addWidget(std::make_unique<Wt::WLineEdit>());
dialog.contents()->addWidget(std::make_unique<Wt::WBreak>());
dialog.contents()->addWidget(std::make_unique<Wt::WPushButton>("Ok"));
// these events will accept() the Dialog
edit.enterPressed().connect(&dialog, &Wt::WDialog::accept);
ok.clicked().connect(&dialog, &Wt::WDialog::accept);
if (dialog.exec() == Wt::WDialog::Accepted)
setStatus("Welcome, " + edit.text());
Wt::WDialog
A WDialog shows a dialog.
Definition WDialog.h:138
Wt::WDialog::accept
virtual void accept()
Closes the dialog, with result is Accepted.

Usage example, using the asynchronous method (recommended):

void MyClass::showDialog()
{
dialog_ = addChild(std::make_unique<Wt::WDialog>("Personalia"));
dialog_->contents()->addWidget(std::make_unique<Wt::WText>("Enter your name: "));
edit_ = dialog_->contents()->addWidget(std::make_unique<Wt::WLineEdit>());
dialog_->contents()->addWidget(std::make_unique<Wt::WBreak>());
Wt::WPushButton *ok = dialog_->contents()->addWidget(std::make_unique<Wt::WPushButton>("Ok"));
// these events will accept() the Dialog
edit_->enterPressed().connect(dialog_, &Wt::WDialog::accept);
ok->clicked().connect(dialog_, &Wt::WDialog::accept);
dialog_->finished().connect(this, &MyClass::dialogDone);
dialog_->show();
}
void MyClass::dialogDone(DialogCode code)
{
if (code == Wt::WDialog::Accepted)
setStatus("Welcome, " + edit_->text());
removeChild(dialog_);
}
Wt::EventSignal::connect
Wt::Signals::connection connect(F function)
Connects to a function.
Definition WSignal.h:810
Wt::WInteractWidget::enterPressed
EventSignal & enterPressed()
Event signal emitted when enter was pressed.
Wt::WInteractWidget::clicked
EventSignal< WMouseEvent > & clicked()
Event signal emitted when the primary mouse button was clicked on this widget.
Wt::WObject::addChild
void addChild(std::unique_ptr< WObject > child)
Add a child WObject whose lifetime is determined by this WObject.
Wt::WObject::removeChild
std::unique_ptr< WObject > removeChild(WObject *child)
Remove a child WObject, so its lifetime is no longer determined by this WObject.
Wt::WPushButton
A widget that represents a push button.
Definition WPushButton.h:42
Wt::DialogCode
DialogCode
The result of a modal dialog execution.
Definition WDialog.h:20

This dialog looks like this (using the default css themes):

A simple custom dialog (default) | A simple custom dialog (polished)

Note
  For the dialog (or rather, the silkscreen covering the user interface below) to render properly in IE, the "html body" margin is set to 0 (if it wasn't already).

## Constructor & Destructor Documentation

## ◆ WDialog() [1/2]

Wt::WDialog::WDialog | ( |  | ) |

Constructs a new dialog.

Unlike other widgets, the dialog does not require a parent container since it is a top-level widget.

## ◆ WDialog() [2/2]

Wt::WDialog::WDialog | ( | const WString & | windowTitle | ) |

Constructs a dialog with a given window title.

Unlike other widgets, the dialog does not require a parent container since it is a top-level widget.

## Member Function Documentation

## ◆ accept()

virtual void Wt::WDialog::accept | ( |  | ) |
| virtual

Closes the dialog, with result is Accepted.

See also
  done(DialogCode r), reject()

## ◆ contents()

WContainerWidget * Wt::WDialog::contents | ( |  | ) | const

Returns the dialog contents container.

Content to the dialog window may be added to this container widget.

## ◆ done()

virtual void Wt::WDialog::done | ( | DialogCode | r | ) |
| virtual

Stops the dialog.

Sets the dialog result, and emits the finished() signal.

If a recursive event loop was started using the exec() method, it is ended.

See also
  finished(), result()

## ◆ enterPressed()

EventSignal & Wt::WDialog::enterPressed | ( |  | ) |

Event signal emitted when enter was pressed.

The event will be triggered if nothing in the WDialog has focus

See also
  WInteractiveWidget::enterPressed

## ◆ escapePressed()

EventSignal & Wt::WDialog::escapePressed | ( |  | ) |

Event signal emitted when escape was pressed.

The event will be triggered if nothing in the WDialog has focus

See also
  WInteractiveWidget::escapePressed

## ◆ exec()

DialogCode Wt::WDialog::exec | ( | const WAnimation & | animation = WAnimation() | ) |

Executes the dialog in a recursive event loop.

Executes the dialog synchronously. This blocks the current thread of execution until one of done(DialogCode), accept() or reject() is called.

Warning: using exec() does not scale to many concurrent sessions, since the thread is locked until exec returns, so the entire server will be unresponsive when the thread pool is exhausted.

See also
  done(DialogCode r), accept(), reject()

## ◆ finished()

Signal< DialogCode > & Wt::WDialog::finished | ( |  | ) |

Signal emitted when the dialog is closed.

See also
  done(DialogCode r), accept(), reject()

## ◆ footer()

WContainerWidget * Wt::WDialog::footer | ( |  | ) | const

Returns the dialog footer container.

This is an optional section which is typically used for buttons.

## ◆ isModal()

bool Wt::WDialog::isModal | ( |  | ) | const

Returns whether the dialog is modal.

See also
  setModal()

## ◆ isTitleBarEnabled()

bool Wt::WDialog::isTitleBarEnabled | ( |  | ) | const

Returns whether the title bar is enabled.

See also
  setTitleBarEnabled()

## ◆ keyPressed()

EventSignal< WKeyEvent > & Wt::WDialog::keyPressed | ( |  | ) |

Event signal emitted when a "character" was entered.

The event will be triggered if nothing in the WDialog has focus

See also
  WInteractiveWidget::keyPressed

## ◆ keyWentDown()

EventSignal< WKeyEvent > & Wt::WDialog::keyWentDown | ( |  | ) |

Event signal emitted when a keyboard key is pushed down.

The event will be triggered if nothing in the WDialog has focus

See also
  WInteractiveWidget::keyWentDown

## ◆ keyWentUp()

EventSignal< WKeyEvent > & Wt::WDialog::keyWentUp | ( |  | ) |

Event signal emitted when a keyboard key is released.

The event will be triggered if nothing in the WDialog has focus

See also
  WInteractiveWidget::keyWentUp

## ◆ movable()

bool Wt::WDialog::movable | ( |  | ) | const

Returns whether the dialog can be moved.

See also
  setMovable()

## ◆ moved()

JSignal< int, int > & Wt::WDialog::moved | ( |  | ) |

Signal emitted when the dialog is being moved by the user.

The information passed are the new x and y position (relative to the wietdow).

## ◆ positionAt()

virtual void Wt::WDialog::positionAt | ( | const WWidget * | widget,
|  | Orientation | orientation = Orientation::Vertical )
| overridevirtual

Positions a widget next to another widget.

Positions this absolutely positioned widget next to another `widget`. Both widgets must be visible (including all their ancestors). The current widget is shown automatically if needed.

When `orientation` = Wt::Orientation::Vertical, the widget is displayed below the other widget (or above in case there is not enough room below). It is aligned so that the left edges align (or the right edges if there is not enough room to the right).

Conversely, when `orientation` = Wt::Orientation::Horizontal, the widget is displayed to the right of the other widget (or to the left in case there is not enough room to the right). It is aligned so that the top edges align (or the bottom edges if there is not enough room below).

Note
  This only works if JavaScript is available.

Reimplemented from Wt::WWidget.

## ◆ reject()

virtual void Wt::WDialog::reject | ( |  | ) |
| virtual

Closes the dialog, with result is Rejected.

See also
  done(DialogCode r), accept()

## ◆ rejectWhenEscapePressed()

void Wt::WDialog::rejectWhenEscapePressed | ( | bool | enable = true | ) |

Lets pressing the escape key reject the dialog.

Before Wt 3.1.5, pressing escape automatically rejected the dialog. Since 3.1.4 this behaviour is no longer the default since it may interfere with other functionality in the dialog. Use this method to enable this behaviour.

See also
  reject()

## ◆ render()

virtual void Wt::WDialog::render | ( | WFlags< RenderFlag > | flags | ) |
| overrideprotectedvirtual

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WPopupWidget.

## ◆ resizable()

bool Wt::WDialog::resizable | ( |  | ) | const

Returns whether the dialog has a resize handle.

See also
  setResizable()

## ◆ resized()

JSignal< int, int > & Wt::WDialog::resized | ( |  | ) |

Signal emitted when the dialog is being resized by the user.

The information passed are the new width and height.

See also
  setResizable()

## ◆ result()

DialogCode Wt::WDialog::result | ( |  | ) | const

Returns the result that was set for this dialog.

See also
  done(DialogCode r)

## ◆ setAutoFocus()

void Wt::WDialog::setAutoFocus | ( | bool | enable | ) |

Set focus on the first widget in the dialog.

Autofocus is enabled by default. If a widget inside of this dialog already has focus, the focus will not be changed.

## ◆ setClosable()

void Wt::WDialog::setClosable | ( | bool | closable | ) |

Adds a close button to the titlebar.

The close button is shown in the title bar. Clicking the close button will reject the dialog.

## ◆ setHidden()

virtual void Wt::WDialog::setHidden | ( | bool | hidden,
|  | const WAnimation & | animation = WAnimation() )
| overridevirtual

Hides or shows the widget.

Hides or show the widget (including all its descendant widgets). When setting `hidden` = `false`, this widget and all descendant widgets that are not hidden will be shown. A widget is only visible if it and all its ancestors in the widget tree are visible, which may be checked using isVisible().

Note
  hide() and show() are considered to be stateless slots by default. If you override setHidden() and need to modify server state whenever it is called, you'll need to call WObject::isNotStateless().

Reimplemented from Wt::WPopupWidget.

Reimplemented in Wt::WMessageBox.

## ◆ setMaximumSize()

virtual void Wt::WDialog::setMaximumSize | ( | const WLength & | width,
|  | const WLength & | height )
| overridevirtual

Sets a maximum size.

Specifies a maximum size for this widget, setting CSS `max-width` and `max-height` properties.

The default the maximum width and height are WLength::Auto, indicating no maximum size. A LengthUnit::Percentage size should not be used, as this is (in virtually all cases) undefined behaviour.

When the widget is a container widget that contains a layout manager, then setting a maximum size will have the effect of letting the size of the container to reflect the preferred size of the contents (rather than constraining the size of the children based on the size of the container), up to the specified maximum size.

See also
  resize(), setMinimumSize()

Reimplemented from Wt::WCompositeWidget.

## ◆ setMinimumSize()

virtual void Wt::WDialog::setMinimumSize | ( | const WLength & | width,
|  | const WLength & | height )
| overridevirtual

Sets a minimum size.

Specifies a minimum size for this widget, setting CSS `min-width` and `min-height` properties.

The default minimum width and height is 0. The special value WLength::Auto indicates that the initial width is used as minimum size. A LengthUnit::Percentage size should not be used, as this is (in virtually all cases) undefined behaviour.

When the widget is inserted in a layout manager, then the minimum size will be taken into account.

See also
  resize(), minimumWidth(), minimumHeight()

Reimplemented from Wt::WCompositeWidget.

## ◆ setModal()

void Wt::WDialog::setModal | ( | bool | modal | ) |

Sets whether the dialog is modal.

A modal dialog will block the underlying user interface. A modal dialog can be shown synchronously or asynchronously. A non-modal dialog can only be shown asynchronously.

By default a dialog is modal.

## ◆ setMovable()

void Wt::WDialog::setMovable | ( | bool | movable | ) |

Allows the dialog to be moved.

The dialog can be moved by grabbing the titlebar.

The default value is `true`.

## ◆ setResizable()

void Wt::WDialog::setResizable | ( | bool | resizable | ) |

Adds a resize handle to the dialog.

The resize handle is shown in the bottom right corner of the dialog, and allows the user to resize the dialog (but not smaller than the content allows).

This also sets the minimum width and height to WLength::Auto to use the initial width and height as minimum sizes. You may want to provide other values for minimum width and height to allow the dialog to be reduced in size.

The default value is `false`.

See also
  setMinimumSize(), setMaximumSize()

## ◆ setTitleBarEnabled()

void Wt::WDialog::setTitleBarEnabled | ( | bool | enabled | ) |

Enables or disables the title bar.

The titlebar is enabled by default.

## ◆ setWindowTitle()

void Wt::WDialog::setWindowTitle | ( | const WString & | title | ) |

Sets the dialog window title.

The window title is displayed in the title bar.

See also
  setTitleBarEnabled()

## ◆ titleBar()

WContainerWidget * Wt::WDialog::titleBar | ( |  | ) | const

Returns the dialog title bar container.

The title bar contains a single text that contains the caption. You may customize the title bar by for example adding other content.

## ◆ windowTitle()

WString Wt::WDialog::windowTitle | ( |  | ) | const

Returns the dialog window title.

See also
  setWindowTitle()